import java.util.ArrayList;
import java.util.Arrays;

public class Graph {
    public int n;
    public int m;
    public Edge[] edges;


    public Graph(int n, int m){
        this.n = n;
        this.m = m;
        edges = new Edge[m];
    }


    public ArrayList<Edge> Kruskal(){
        ArrayList<Edge> MST = new ArrayList<Edge>();
        UnionFind union = new UnionFind(n);
        
        Arrays.sort(edges);

        for(Edge e: edges){
            int a = e.from;
            int b = e.to;
            if(union.find(a) != union.find(b)){
                MST.add(e);
                union.union(a, b);
            }
        }

    
        return MST;
    }
}
