public class UnionFind{
    int[] parent;
    int[] rank;

    public UnionFind(int n){
        for(int i = 0; i <n; i++){
            parent[i] = i;
            rank[i] = 1;
        }
    }


    int find(int x){
        if(x == parent[x]){
            return x;
        }
        int root = find(parent[x]);
        parent[x] = root;
        return root;
    }


    void union(int a, int b){
        int aroot = find(a);
        int broot = find(b);

        if(rank[broot] > rank[aroot]){
            parent[aroot] = broot;

        } else if(rank[aroot] > rank[broot]){
            parent[broot] = aroot;
        } else{
            parent[aroot] = broot;
            rank[aroot]++;
        }
    }

    
}